<?php

function abstand($c1, $c2) {
 $r1 = ($c1 >> 16) & 0xFF;
 $g1 = ($c1 >> 8) & 0xFF;
 $b1 = $c1 & 0xFF;
 
 $r2 = ($c2 >> 16) & 0xFF;
 $g2 = ($c2 >> 8) & 0xFF;
 $b2 = $c2 & 0xFF;
 return abs($r1 - $r2) + abs($g1 - $g2) + abs($b1 - $b2);
}

if ($_SERVER["argc"] < 3) {
 echo "php imagediff.php file1 file2\n\n";
 exit(1);
}

// Dateien öffnen
$file1 = $_SERVER["argv"][1];
$file2 = $_SERVER["argv"][2];

echo "Vergleiche " . $file1 . " und " . $file2 . "\n";

$img1 = @imagecreatefromjpeg($file1);
$img2 = @imagecreatefromjpeg($file2);

// Weitere Tests
$gleichGross = (imagesx($img1) == imagesx($img2)) 
                && (imagesy($img1) == imagesy($img2));
if (!$gleichGross) {
 echo "Die Bilder sind nicht gleich groß\n";
 exit(1);
}




// Beide Grafiken in die Zieldatei kopieren
$w = imagesx($img1);
$h = imagesy($img1);

$diff = imagecreatetruecolor($w * 2, $h);

imagecopy ($diff, $img1, 0, 0, 0, 0, $w, $h);
imagecopy ($diff, $img2, $w, 0, 0, 0, $w, $h);

// Farbe für die gleichen Bildpunkte festlegen
$t1 = imageColorAllocateAlpha($diff, 0, 0, 0, 0);

// Alle Punktepunkte vergleichen
$count = 0;
for($y=0; $y<$h; $y++) {
  for($x=0; $x<$w; $x++) {
    $c1 = imagecolorat($img1, $x, $y);
    $c2 = imagecolorat($img2, $x, $y);
    if (abstand($c1, $c2) < 10) {
      imagesetpixel ($diff, $x, $y, $t1);         
      imagesetpixel ($diff, $x + $w, $y, $t1);         
      $count++;
    }
  }
}

// Speichern
imagejpeg($diff, "diff_" . basename($file1). "_" . basename($file2). ".jpg");
$uebereinstimmung = (int)($count / ($h * $w) * 100);
echo "Bilder stimmen zu " .$uebereinstimmung. "% überein\n";

?>